/* lab9a.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>

#define I_MAX_VALOR     254
#define SZ_FORMATO      "Formato: p <#posicoes> <#produtores> <#consumidores>\n"
#define SZ_MAX_THREADS  "O maximo de threads permitido e' %d\n"
#define SZ_POS_POSICOES "O numero de posicoes deve ser positivo\n"
#define SZ_MAX_POSICOES "O maximo de posicoes permitido e' %d\n"
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d\n"
#define SZ_NUM_THREADS  "Numero de threads %d\n"
#define SZ_CONSUMINDO   "Consumidor %d esta' consumindo mensagem %d\n"
#define SZ_PRODUZINDO   "Produtor %d esta' produzindo a mensagem %d\n"
#define SZ_CONS_ESPERA  "Consumidor %d esperando mensagem\n"
#define SZ_PROD_ESPERA  "Produtor %d esperando espaco no buffer\n"    


typedef struct {
   pthread_mutex_t MonitorBuffer            ;
   pthread_cond_t  CondConsumidor           ,
                   CondProdutor             ;
   int             front                    ,
                   rear                     ,
                   count                    ,
                   Mensagens[ I_MAX_VALOR ] ,
                   Posicao[ I_MAX_VALOR ]   ,
                   JaLeram[ I_MAX_VALOR ]   ,
                   JaLidas[ I_MAX_VALOR ]   ;
} tpBuffer ;


int      b                                     ,  /* posicoes */
         n                                     , /* produtores */
         m                                     ; /* consumidores */
tpBuffer Buffer = { PTHREAD_MUTEX_INITIALIZER, 
                    PTHREAD_COND_INITIALIZER , 
                    PTHREAD_COND_INITIALIZER , 
                    0, 0, 0 }                  ;


void* ProcessoConsumidor( void* MeuId ) ;

void* ProcessoProdutor( void* MeuId ) ;

int retira( int iMeuId ) ;

void deposita( int iMensagem ,
               int iMeuId     ) ;

void Esperar( int iMeuId ) ;


void* ProcessoConsumidor( void* MeuId ) {
   int iMeuId    = *( int* )MeuId ,
       iMensagem                  ;

   while ( 1 ) {
      iMensagem = retira( iMeuId ) ;
      printf( SZ_CONSUMINDO, iMeuId, iMensagem ) ;
      fflush( stdout ) ;
      Esperar( iMeuId ) ;
   } /* while */
} /* ProcessoConsumidor */


void* ProcessoProdutor( void* MeuId ) {
   int iMeuId    = *( int* )MeuId ,
       iMensagem                  ;

   srand( time( NULL ) ) ;

   while ( 1 ) {
      iMensagem = 1 + ( int )( ( ( double )I_MAX_VALOR * rand( ) )
                             / ( RAND_MAX + 1.0 ) ) ;
      printf( SZ_PRODUZINDO, iMeuId, iMensagem ) ;
      fflush( stdout ) ;
      deposita( iMensagem, iMeuId ) ;
      Esperar( iMeuId ) ;
   } /* while */
} /* ProcessoProdutor */


int retira( int iMeuId ) {
   int iMensagem ;

   pthread_mutex_lock( &Buffer.MonitorBuffer ) ;
   
   while ( Buffer.count == 0 
        || Buffer.JaLidas[ iMeuId ] == Buffer.count ) {
        
      printf( SZ_CONS_ESPERA, iMeuId ) ;
      fflush( stdout ) ;
      pthread_cond_wait( &Buffer.CondConsumidor, &Buffer.MonitorBuffer ) ;
   } /* while */

   iMensagem = Buffer.Mensagens[ Buffer.Posicao[ iMeuId ] ] ;
   Buffer.JaLeram[ Buffer.Posicao[ iMeuId ] ]++ ;
   Buffer.JaLidas[ iMeuId ]++ ;

   if ( Buffer.JaLeram[ Buffer.Posicao[ iMeuId ] ] == m ) {
      int i ;

      Buffer.JaLeram[ Buffer.Posicao[ iMeuId ] ] = 0 ;
      Buffer.front = ( Buffer.front + 1 ) % b ;
      Buffer.count-- ;
      pthread_cond_signal( &Buffer.CondProdutor ) ;
      
      for ( i = 0 ; i < m ; i++ ) {
         Buffer.JaLidas[ i ]-- ;
      } /* for */

   } /* if */    

   Buffer.Posicao[ iMeuId ] = ( Buffer.Posicao[ iMeuId ] + 1 ) % b ;
   pthread_mutex_unlock( &Buffer.MonitorBuffer ) ;

   return iMensagem ;
} /* retira */


void deposita( int iMensagem ,
               int iMeuId     ) {
   
   pthread_mutex_lock( &Buffer.MonitorBuffer ) ;
   
   while ( Buffer.count == b ) {
      printf( SZ_PROD_ESPERA, iMeuId ) ;
      fflush( stdout ) ;
      pthread_cond_wait( &Buffer.CondProdutor, &Buffer.MonitorBuffer ) ;
   } /* while */

   Buffer.Mensagens[ Buffer.rear ] = iMensagem ;
   Buffer.rear = ( Buffer.rear + 1 ) % b ;
   Buffer.count++ ;
   pthread_cond_broadcast( &Buffer.CondConsumidor ) ;

   pthread_mutex_unlock( &Buffer.MonitorBuffer ) ;
} /* deposita */


void Esperar( int iMeuId ) {
   unsigned long int i                                        ,
                     lTotal = ( unsigned long )10000000L 
                            * ( unsigned long )( iMeuId + 1 ) ;

   for ( i = 0 ; i < lTotal ; i++ ) { }
} /* Esperar */


int main( int   argc    ,
          char* argv[ ]  ) {

   int       i                     ,
             iErro                 ;
   int*      pMeuId                ;
   pthread_t Thread[ I_MAX_VALOR ] ;

   if ( argc != 4 ) {
      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   b = atoi( argv[ 1 ] ) ;
   n = atoi( argv[ 2 ] ) ;
   m = atoi( argv[ 3 ] ) ;

   if ( n + m > I_MAX_VALOR ) {
      printf( SZ_MAX_THREADS, I_MAX_VALOR ) ;
      return 0 ;
   } /* if */

   if ( b <= 0 ) {
      printf( SZ_POS_POSICOES ) ;
      return 0 ;
   } /* if */

   if ( b > I_MAX_VALOR ) {
      printf( SZ_MAX_POSICOES, I_MAX_VALOR ) ;
      return 0 ;
   } /* if */

   printf( SZ_NUM_THREADS, n + m ) ;
   
   for ( i = 0 ; i < b ; i++ ) {
      Buffer.Mensagens[ i ] = -1 ;
      Buffer.JaLeram[ i ] = 0 ;
   } /* for */

   for ( i = 0 ; i < m ; i++ ) {
      Buffer.Posicao[ i ] = 0 ;
      Buffer.JaLidas[ i ] = 0 ;
   } /* for */

   for ( i = 0 ; i < n + m ; i++ ) {
      pMeuId = ( int* )malloc( sizeof( int ) ) ;
      *pMeuId = i ;

      if ( i < m ) {
         iErro = pthread_create( &Thread[ i ], NULL, ProcessoConsumidor,
                                                     ( void* )( pMeuId ) ) ;
      } else {
         iErro = pthread_create( &Thread[ i ], NULL, ProcessoProdutor,
                                                     ( void* )( pMeuId ) ) ;
      } /* if */ 

      if ( iErro != 0 ) {
         printf( SZ_ERRO_CRIA, i ) ;
         return 1 ;
      } /* if */
   } /* for */

   pthread_exit( NULL ) ;

   return 0 ;
}
